-- name: \\#b2ccff\\Jumping Ending Credits \\#b2cc66\\V2
-- description: 
gGlobalSyncTable.isActive = true

local function get_isActive() 
    return gGlobalSyncTable.isActive
end

local function set_IsActive(newValue) 
    gGlobalSyncTable.isActive = newValue
end

local function toggle_IsActive() 
    set_IsActive(not get_isActive())
end


local function change_single_jump_animation(m)
    if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_SINGLE_JUMP then
        smlua_anim_util_set_animation(m.marioObj, "mario_anim_replace_jumping")
    end
end

local function change_double_jump_animation(m)
    if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_DOUBLE_JUMP_RISE then
        smlua_anim_util_set_animation(m.marioObj, "mario_anim_replace_double")
    end
    if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_DOUBLE_JUMP_FALL then
        smlua_anim_util_set_animation(m.marioObj, "anim_4_geez")
    end
end

local function change_triple_jump_animation(m)
    if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_TRIPLE_JUMP then
        smlua_anim_util_set_animation(m.marioObj, "mario_anim_replace_triple")
    end
end

local function mario_update(m)
    if get_isActive() == false then 
        return
    end
    change_single_jump_animation(m)
    change_double_jump_animation(m)
    change_triple_jump_animation(m)
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

local function chat_command(msg)
    toggle_IsActive()
    djui_chat_message_create(get_isActive() and "Jumping Animation Enable" or "Jumping Animation Disable")
    return true
end
hook_chat_command("jump-animation", "- Toggles Jumping Animation", chat_command)

_G.jumpingAnimExists = true
_G.jumpingAnim = {
    change_single_jump_animation = change_single_jump_animation,
    change_double_jump_animation = change_double_jump_animation,
    change_triple_jump_animation = change_triple_jump_animation,
    get_isActive = get_isActive,
    set_IsActive = set_IsActive,
    toggle_IsActive = toggle_IsActive,
}
